import {
    Document,
    Model,
    model,
    Schema,
    SchemaTimestampsConfig,
  } from 'mongoose'
import { uuidv4 } from '@firebase/util'
import { Embedding } from 'openai/resources'
import { Service } from './room'


export interface ICommandVector {
    _id?: string
    command: string
    room: string
    controll: Service
    vector: number[]
}
interface ICommandDocument extends ICommandVector, Document, SchemaTimestampsConfig {
    _id: string
  }

type ICommandModel = Model<ICommandDocument>


const commandSchema = new Schema<ICommandDocument,ICommandModel >(
    {
        _id: {
            type: String,
            default: () => uuidv4(),
        },
        command: {
            type: String,
            required: true
        },
        room: {
            type: String,
            required: true
        },
        controll: {
            type: Object,
            required: true
        },
        vector: {
            type: [Number],
            required: true
        }
    },
    {
        timestamps: true,
    },
)

export default model<ICommandDocument, ICommandModel>('commandVector', commandSchema,"commandVector")

