import asyncio
import pyaudio
import queue
from google.cloud import speech, texttospeech
from pydub import AudioSegment
from pydub.playback import _play_with_simpleaudio
from openai import OpenAI
import io
import threading
import time
from openai import OpenAI
from google.api_core.exceptions import OutOfRange
import requests
from  apiService import CommandManager
from  speechSystem import SpeechSystem

# Initialize the OpenAI client with your API key
client = OpenAI(api_key="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")

# Define wake words
WAKE_WORDS = ["hey, sophia", "okay, sophia", "hi, sophia", "hello, sophia","sophia","โซเฟีย"]

# Audio recording parameters
RATE = 16000
CHUNK = int(RATE / 10)  # 100ms


class MicrophoneStream(object):
    def __init__(self, rate, chunk):
        self._rate = rate
        self._chunk = chunk
        self._buff = queue.Queue()
        self.closed = True
        self._mute = False

    def __enter__(self):
        self._audio_interface = pyaudio.PyAudio()
        self._audio_stream = self._audio_interface.open(
            format=pyaudio.paInt16,
            channels=1, rate=self._rate,
            input=True, frames_per_buffer=self._chunk,
            stream_callback=self._fill_buffer,
        )
        self.closed = False
        return self

    def __exit__(self, type, value, traceback):
        self._audio_stream.stop_stream()
        self._audio_stream.close()
        self.closed = True
        self._buff.put(None)
        self._audio_interface.terminate()

    def mute(self):
        """Prevent the microphone from capturing data."""
        self._mute = True

    def unmute(self):
        """Allow the microphone to capture data."""
        self._mute = False

    def _fill_buffer(self, in_data, frame_count, time_info, status_flags):
        # print('self._mute', self._mute)
        if not self._mute:  # Only put data in the buffer if not muted
            self._buff.put(in_data)
        return None, pyaudio.paContinue

    def generator(self):
        while not self.closed:
            chunk = self._buff.get()
            if chunk is None:
                return
            data = [chunk]

            while True:
                try:
                    chunk = self._buff.get(block=False)
                    if chunk is None:
                        return
                    data.append(chunk)
                except queue.Empty:
                    break

            yield b''.join(data)

def speak_with_sophia(speech_system, mic_stream, text):
    response = client.chat.completions.create(
        model="gpt-3.5-turbo",
        messages=[
                    {
            "role": "system",
            "content": "your name is sophere."
            },
            
            {
            "role": "user",
            "content": text
            }
        ],
        temperature=1,
        max_tokens=256,
        top_p=1,
        frequency_penalty=0,
        presence_penalty=0
        )
    speech_system.synthesize_and_play_text(response.choices[0].message.content, mic_stream)

def is_wake_word_detected(transcript):
    """Checks if the wake word is present in the given transcript."""
    return any(wake_word in transcript.lower() for wake_word in WAKE_WORDS)

def listen_print_loop(responses, mic_stream, speech_system,CommandManager):
        listening_for_command = False  # Flag to indicate if we are listening for commands
        
        for response in responses:
            if not response.results or speech_system.is_speaking:
                continue  # Ignore input while speaking

            result = response.results[0]
            if not result.alternatives:
                continue

            transcript = result.alternatives[0].transcript

            if result.is_final:
                print(transcript)
                
                if is_wake_word_detected(transcript) and not listening_for_command:
                    listening_for_command = True
                    speech_system.synthesize_and_play_text("How can I help you?", mic_stream)
                    continue
                

                if listening_for_command:
                    print("Listening for command...")
                    if "exit" in transcript.lower():
                        print("Exit command recognized, exiting program.")
                        break
                    elif cmd.edit_service(transcript):
                        speech_system.synthesize_and_play_text("Command executed successfully.", mic_stream)
                        listening_for_command = False  # Reset listening flag after processing command
                    else:
                        speech_system.synthesize_and_play_text("Command executed successfully.", mic_stream)
                        listening_for_command = False
                        # print("try again")
                        
                            # speech_system.synthesize_and_play_text(transcript, mic_stream)
                        # speech_system.synthesize_and_play_text("wait a moment",mic_stream)
                        # while speech_system.is_speaking:
                        #     # print("waiting for speech to finish...",speech_system.is_speaking)
                        #     time.sleep(0.1)
                        # answer  = can_speak_with_sophia(transcript)
                        # print(answer)
                        # if(answer.lower().strip(".") == "no"):
                        #     if(asyncio.run(are_phrases_similar_async(transcript, "What is the price of bitcoin?"))):
                        #         speech_system.synthesize_and_play_text(f"The current price of Bitcoin is {get_bitcoin_price()} USD.", mic_stream)
                        #     else:
                        #         speech_system.synthesize_and_play_text("I'm sorry, I cannot answer that question without real-time information.", mic_stream)
                        # else:
                        #     speech_system.synthesize_and_play_text(answer, mic_stream)
                            
                        # listening_for_command = False  # Reset listening flag after processing command
                        
                        # if(check_is_real_time_question(transcript)):
                        #     if(asyncio.run(are_phrases_similar_async(transcript, "What is the price of bitcoin?"))):
                        #         speech_system.synthesize_and_play_text(f"The current price of Bitcoin is {get_bitcoin_price()} USD.", mic_stream)
                        #     else:
                        #         speech_system.synthesize_and_play_text("I'm sorry, I cannot answer that question without real-time information.", mic_stream)
                        # else:
                        #     speak_with_sophia(speech_system, mic_stream, transcript)
                        # listening_for_command = False  # Reset listening flag after processing command

def check_is_real_time_question(transcript:str):
    response = client.chat.completions.create(
        model="gpt-3.5-turbo",
        messages=[
            {
            "role": "system",
            "content": "Given a list of questions, determine which ones cannot be answered without real-time information. For questions that require real-time information to be answered accurately, respond with \"no\". If a question does not require real-time information and can be answered with the knowledge available up to April 2023, provide an answer to that question."
            },
            {
            "role": "user",
            "content": f"{transcript}"
            }
        ],
        temperature=1,
        max_tokens=256,
        top_p=1,
        frequency_penalty=0,
        presence_penalty=0
    )
    return response.choices[0].message.content.strip().lower() == "no"

def can_speak_with_sophia(transcript:str):
    response = client.chat.completions.create(
        model="gpt-3.5-turbo",
        messages=[
            {
            "role": "system",
            "content": "Given a list of questions, determine which ones cannot be answered without real-time information. For questions that require real-time information to be answered accurately, respond with \"no\". If a question does not require real-time information and can be answered with the knowledge available up to April 2023, provide an answer to that question.And Your name is Sophia"
            },
            {
            "role": "user",
            "content": f"{transcript}"
            }
        ],
        temperature=1,
        max_tokens=256,
        top_p=1,
        frequency_penalty=0,
        presence_penalty=0
        )
    return response.choices[0].message.content.strip().lower()
  # Indicate the thread is stopping

    
async def are_phrases_similar_async(phrase1, phrase2):
    loop = asyncio.get_running_loop()
    
    def get_response():
        response = client.chat.completions.create(
        model="gpt-3.5-turbo",
        messages=[
                    {
            "role": "system",
            "content": "your name is sophere"
            },
            {
            "role": "user",
            "content": f"Are the following phrases expressing the same intent? \\n\\n1. {phrase1}\\n2. {phrase2}\\n\\nAnswer with 'yes' if they are similar, or 'no' if they are not.\""
            }
        ],
        temperature=1,
        max_tokens=256,
        top_p=1,
        frequency_penalty=0,
        presence_penalty=0
        )
        # print(response.choices[0].text.strip().lower())
       
        
        return response.choices[0].message.content.strip().lower() == "yes"
    
    return await loop.run_in_executor(None, get_response)

def get_bitcoin_price():
    url = "https://api.coingecko.com/api/v3/simple/price?ids=bitcoin&vs_currencies=usd"
    response = requests.get(url)
    data = response.json()
    return data['bitcoin']['usd']
# def get_light_status(room:str):
#     url = f"https://embeddedhardware-production.up.railway.app/room/{room}"
#     response = requests.get(url)
#     # print(response.json())
#     return response.json()["light"]
# def set_light_status(room:str, status:bool):
#     url = f"https://embeddedhardware-production.up.railway.app/room/edit/"
#     response = requests.put(url, json={"name": room, "light": status})
#     # print(response)
#     return response.json()["light"]

def main(speech_system=SpeechSystem(),cmd=CommandManager(),polling_thread=None):
    client = speech.SpeechClient()

    config = speech.RecognitionConfig(
        encoding=speech.RecognitionConfig.AudioEncoding.LINEAR16,
        sample_rate_hertz=RATE,
        language_code='en-US',
        enable_automatic_punctuation=True,
    )
    streaming_config = speech.StreamingRecognitionConfig(
        config=config,
        interim_results=True,
    )
    try:
        
        with MicrophoneStream(RATE, CHUNK)  as stream:
            if(polling_thread is None):
                polling_thread = threading.Thread(target=cmd.emergency_polling, args=(stop_polling_event,speech_system,stream))  # Step 2
                polling_thread.start()
            print("Say the wake word and speak...")
            audio_generator = stream.generator()
            requests = (speech.StreamingRecognizeRequest(audio_content=content) for content in audio_generator)
            responses = client.streaming_recognize(streaming_config, requests)
            listen_print_loop(responses, stream, speech_system=speech_system,CommandManager=cmd)
            if(polling_thread is not None):
                polling_thread.join()
            # stop_polling_event.set()  # Step 3
            # Wait for the polling thread to finish
            print("Main program and polling thread have exited.")
    except OutOfRange:
        print("Audio Timeout Error detected, attempting to recover...")
        while speech_system.is_speaking:
            time.sleep(0.1)  # Wait a bit for the speech to finish
        # Here you could place a mechanism to restart the recognition process
        # For example, by calling main() again, or by extracting the stream initiation
        # and response handling into a separate function that can be called again here.
        main(cmd=cmd, speech_system=speech_system,polling_thread=polling_thread)  # Recursive call to restart the process. Be cautious with recursion for error handling.

stop_polling_event = threading.Event()  # Step 1
if __name__ == '__main__':
    cmd = CommandManager()
    speech_system = SpeechSystem()
    polling_thread = None
    main(cmd=cmd, speech_system=speech_system,polling_thread=polling_thread)

   
