import requests as req
from urllib.parse import urljoin
from all_commands import all_commands
import time
from speechSystem import SpeechSystem
from global_varibles import emergancy
prefix  = "https://embeddedhardware-production.up.railway.app/"
class CommandManager:
    def __init__(self):
        self.commands = []

    def add_command(self, command):
        if command not in self.commands:
            res = req.post(urljoin(prefix, "/commandVector/create"), json={
                "command":command["command"].lower(),
                "room":command["room"].lower(),
                "controll":command["service"]
                })

        self.commands.append(command)

    def search_command(self, search_term):
        if(search_term != "" and search_term != None):
            res = req.post(urljoin(prefix, "/commandVector/search"), json={
            "command":search_term.lower(),
            })
            return res.json()

    def edit_service(self,command) -> bool:
        try:
            doc = self.search_command(command)
            if doc == []:
                return False
            res =  req.put(urljoin(prefix, "/room/edit"), json={
                "name": doc[0]["room"],
                "service": doc[0]["controll"]
            } )
            return True
        except Exception as e:
            print(e)
            return False
    
    def emergency_polling(self, stop_event,speaker : SpeechSystem = None,mic_stream = None):
        while not stop_event.is_set():
            try:
                time.sleep(10)  # Adjust polling frequency as needed
                # print("Polling for emergencies...")
                response = req.get(urljoin(prefix, "/room/emergency"))
                print(response.json())
                if response.ok and response.json() == True:
                    print("Emergency detected!")
                    if speaker is not None or mic_stream is not None:
                        speaker.synthesize_and_play_text("Emergency detected! Please check the house.", mic_stream)
                else:
                    print("No emergency.")
            except req.exceptions.RequestException as e:
                print(f"Error during polling: {e}")
            finally:
                pass
                # print("Polling iteration completed.")

        # print("Emergency polling stopped.")



