import asyncio
import pyaudio
import queue
from google.cloud import speech, texttospeech
from pydub import AudioSegment
from pydub.playback import _play_with_simpleaudio
from openai import OpenAI
import io
import threading
import time
from openai import OpenAI
from google.api_core.exceptions import OutOfRange
import requests


class SpeechSystem:
    
    def __init__(self):
        self.is_speaking = False
        self.RATE = 16000

    def synthesize_and_play_text(self, text, mic_stream):
        """Synthesizes speech from the input string of text and plays it.Answer less than 75 tokens"""
        self.is_speaking = True
        def _play_audio():
            try:
                tts_client = texttospeech.TextToSpeechClient()
                input_text = texttospeech.SynthesisInput(text=text)
                voice = texttospeech.VoiceSelectionParams(
                    language_code='en-US',
                    name='en-US-Wavenet-C',  
                    ssml_gender=texttospeech.SsmlVoiceGender.NEUTRAL)
                audio_config = texttospeech.AudioConfig(
                    audio_encoding=texttospeech.AudioEncoding.MP3)

                response = tts_client.synthesize_speech(input=input_text, voice=voice, audio_config=audio_config)

                # Decode the MP3 data
                audio = AudioSegment.from_file(io.BytesIO(response.audio_content), format="mp3")
                
                _play_with_simpleaudio(audio)
                time.sleep(len(audio) / 1000 + 0.2)
                
                
            except Exception as e:
                
                print(f"An error occurred: {e}")
                
            finally:
                
                mic_stream.unmute()
                self.is_speaking = False
                

        mic_stream.mute()
        thread = threading.Thread(target=_play_audio)
        thread.start()
        
    
        